(function (sugo) {
               sugo.enable_page_event = $sugo_enable_page_event$;
               if (window.sugo && sugo.enable_page_event) {
                   sugo.stayTime();
               }
               sugo.auto_track = "$sugo_auto_track$";
               sugo.single_code = "";
               sugo.relative_path = "$sugo_relative_path$";
               sugo.url = "$sugo_url$";
               sugo.all_page_info = $all_page_info$;
               sugo.init = {
                    "code":  "$sugo_init_code$",
                    "page_name":  "$sugo_init_page_name$",
                    "page_category":  "$sugo_init_page_category$"
               };
               if(window.$curpagenoPV$){
                 sugo.relative_path = decodeURI(window.$curpagenoPV$);
               }else if (window.$curpageurlPV$){
                 sugo.relative_path = decodeURI(window.$curpageurlPV$);
               }
               if(sugo.relative_path.indexOf('?') !== -1){
                    sugo.relative_path = sugo.relative_path.substring(0,sugo.relative_path.indexOf('?'))
               }
               if(sugo.relative_path.indexOf('.jsp') !== -1){
                    sugo.relative_path = sugo.relative_path.substring(0,sugo.relative_path.indexOf('.jsp')+4)
               }
               if(sugo.relative_path.indexOf('/sTokenID=') !== -1){
                    sugo.relative_path = sugo.relative_path.substring(0,sugo.relative_path.indexOf('/sTokenID='))
               }

               sugo.view_props = {};
               sugo.relative_path = sugo.relative_path.replace("#/", "#");
               sugo.relative_path = sugo.relative_path.replace("//", "/");
               sugo.rawTrack = function (event_id, event_name, props) {
                    if (!props) {
                       props = {};
                    }
                    if(sugo.single_code) {
                     props.$sugo_path_name$ = sugo.relative_path +  "##" + sugo.single_code;
                    } else {
                     props.$sugo_path_name$ = sugo.relative_path;
                    }

                    if (!props.$sugo_page_name$ && sugo.init.page_name) {
                       props.$sugo_page_name$ = sugo.init.page_name;
                    }
                    if (!props.$sugo_page_category_key$ && sugo.init.page_category) {
                       props.$sugo_page_category_key$ = sugo.init.page_category;
                    }
                    props.$sugo_h5_url$ = window.location.href;
                    props.$sugo_h5_domain$ = window.location.origin + window.location.pathname;
                    if(window.$curpagenoPV$){
                       props.$curpagenoPV$ = decodeURI(window.$curpagenoPV$);
                    }
                    if(window.$curpagenamePV$){
                       props.$curpagenamePV$ = decodeURI(window.$curpagenamePV$);
                    }
//                    console.log("sugo.rawTrack,event_name:" + event_name);
                    window.sugoEventListener && window.sugoEventListener.track(event_id, event_name, JSON.stringify(props));
               };
               sugo.track = function (event_name, props) {
                   sugo.rawTrack("", event_name, props);
               };
               sugo.timeEvent = function (event_name) {
                   window.sugoEventListener && window.sugoEventListener.timeEvent(event_name);
               };

               sugo.registerSuperProperties = function(props) {
                       window.sugoEventListener && window.sugoEventListener.registerSuperProperties(JSON.stringify(props));
               };
               sugo.login = function(key, value) {
                   window.sugoEventListener && window.sugoEventListener.login(key, value)
               };
               sugo.logout = function(key, value) {
                   window.sugoEventListener && window.sugoEventListener.logout()
               };
               sugo.browser = function(){
                  if (sugo.enable_page_event) {
                      var hidden_ele = document.getElementById("eventdataid");
                      if (hidden_ele){
                          var value = hidden_ele.getAttribute("value");
                          if (value){
                               sugo.view_props["eventdata_id"] = value;
                          }
                      }
                       if (sugo && sugo.init.code) {
                          var view_props = {};
                          try {
                              var init_code = new Function("sugo", sugo.init.code);
                              view_props = init_code(sugo);
                          } catch (e) {
                              console.log(sugo.init.code);
                              view_props = {};
                          }
                          sugo.view_props = Object.assign({}, sugo.view_props, view_props);
                      }
                      var title = document.title;
                      if (title){
                           sugo.view_props["page_name"] = title;
                      }
                      var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                      tmp_props.curpageurl = document.location.href;
                      debugger;
                      sugo.track("浏览", tmp_props);
                      sugo.enter_time = new Date().getTime();
                  }
               };
               sugo.browser();
               sugo.stayTime = function(){
                 var tmp_duration = (new Date().getTime() - sugo.enter_time) / 1000;
                 var tmp_props = JSON.parse(JSON.stringify(sugo.view_props));
                 var hidden_ele = document.getElementById("eventdataid");
                 if (!tmp_props["eventdata_id"] && hidden_ele) {
                     var value = hidden_ele.getAttribute("value");
                     if (value){
                          tmp_props["eventdata_id"] = value;
                     }
                 }
                 tmp_props.duration = tmp_duration;
                 tmp_props.curpageurl = document.location.href;
                 sugo.track("停留", tmp_props);
               };
               if (!window.sugo && sugo.enable_page_event) {
                   window.addEventListener("unload", function (e) {
                       sugo.stayTime();
                   });
               }
               sugo.current_page = sugo.relative_path;
               sugo.h5_event_bindings = $sugo_h5_event_bindings$;
               sugo.h5_event_bindings_ex = $sugo_h5_event_bindings_ex$;
               sugo.sugo_hashcode = $sugo_hashcode$;
               sugo.current_event_bindings = {};
               console.log("sugo.relative_path:" + sugo.relative_path);
               var isbindings = false;
               for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                   var b_event = sugo.h5_event_bindings[i];
//                   console.log("sugo.b_event.target_activity:" + b_event.target_activity);
                   if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                       isbindings = true;
                       var b_key = JSON.stringify(b_event.path);
                       sugo.current_event_bindings[b_key] = b_event;
                   }
               }

               if(isbindings === false){
                   if(sugo.h5_event_bindings_ex){
                       for (var i = 0; i < sugo.h5_event_bindings_ex.length; i++) {
                           var bEventEx = sugo.h5_event_bindings_ex[i];
                           if (bEventEx.target_activity === sugo.current_page || bEventEx.cross_page || bEventEx.target_activity === sugo.relative_path) {
                               isbindings = true;
                               var key = JSON.stringify(bEventEx.path);
                               sugo.current_event_bindings[key] = bEventEx;
                           }
                       };
                   }
               }
               console.log("sugo.isbindings:" + isbindings);

               sugo.isElementInViewport = function (rect) {
                   return ( rect.top >= 0 && rect.left >= 0 && rect.bottom <= sugo.clientHeight && rect.right <= sugo.clientWidth);
               };
               sugo.excludeControl = ["symbol", "SCRIPT"];
               sugo.handleNodeChild = function(childrens, nodeJSONArray, parent_path) {
                   var scale = window.screen.width / (window.innerWidth || document.documentElement.clientWidth);
                   for (var i = 0; i < childrens.length; i++) {
                       var nodeChildren = childrens[i];
                       if(!sugo.isVisible(nodeChildren)){
                           continue;
                       }
                       if (sugo.excludeControl.indexOf(nodeChildren.tagName) >= 0) {
                           continue;
                       }
                       var rect = {top:0, left:0, width:0, height:0};
                       if(nodeChildren.tagName == "AREA"){
                           rect = sugo.getSpecialElementRect(nodeChildren);
                       }else{
                           rect = nodeChildren.getBoundingClientRect();
                       }
                       var htmlNode = {};
                       var temp_rect = {
                           top: rect.top * scale,
                           left: rect.left * scale,
                           width: rect.width * scale,
                           height: rect.height * scale
                       };
                       htmlNode.rect = temp_rect;
                       var childPath = sugoioKit.cssPath(nodeChildren).replace(/  /g," ");
                       htmlNode.path = childPath;
                       htmlNode.classList = nodeChildren.classList;
                       var innerText =  nodeChildren.innerText || "";
                       if (innerText.length > 0) {
                           innerText = innerText.replace(/(^\s*)|(\s*$)/g, "");
                       }
                       if(innerText.length > 29){
                          htmlNode.sugo_autotrack_content = innerText.substring(0,30);
                       }else{
                          htmlNode.sugo_autotrack_content = innerText;
                       }
                       nodeJSONArray.push(htmlNode);
                       if (nodeChildren.children) {
                           sugo.handleNodeChild(nodeChildren.children, nodeJSONArray, childPath);
                       }
                   }
               };
               sugo.isVisible = function isInViewPort(el) {
                            const viewPortHeight = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
                            const top = el.getBoundingClientRect() && el.getBoundingClientRect().top;
                            return top  < viewPortHeight ;
                        };
               sugo.getSpecialElementRect = function(element) {
                  var rect = {top:0, left:0, width:0, height:0};
                  if(element.tagName == "AREA" && element.shape == "rect"){
                      var parentNode = element.parentNode;
                      var mapX = 0;
                      var mapTop = 0;
                      if(parentNode.tagName == "MAP"){
                          var mapRect = parentNode.getBoundingClientRect();
                          mapTop = mapRect.top;
                          mapX =  mapRect.x;
                      }
                      var coords = element.coords;
                      var coordsArray = coords.split(",");
                      var x1 = coordsArray[0];
                      var y1 = coordsArray[1];
                      var x2 = coordsArray[2];
                      var y2 = coordsArray[3];
                      rect = {
                        top:parseInt(y1)+parseInt(mapTop),
                        left:parseInt(x1)+parseInt(mapX),
                        width:parseInt(x2-x1),
                        height:parseInt(y2-y1)
                      }
                  }
                  return rect;
               };
               sugo.reportNodes = function () {
                   var startTime = new Date().getTime();
                   var nodeJSONArray = [];
                   var body = document.getElementsByTagName("body")[0];
                   var childrens = body.children;
                   var parent_path = "";
                   sugo.clientWidth = (window.innerWidth || document.documentElement.clientWidth);
                   sugo.clientHeight = (window.innerHeight || document.documentElement.clientHeight);
                   sugo.handleNodeChild(childrens, nodeJSONArray, parent_path);
                   if (window.sugoWebNodeReporter) {
                       var curpagenoPV = "";
                       if(window.$curpagenoPV$){
                         curpagenoPV = decodeURI(window.$curpagenoPV$);
                       }
                       var curpagenamePV = "";
                       if(window.$curpagenamePV$){
                         curpagenamePV = decodeURI(window.$curpagenamePV$);
                       }
                       window.sugoWebNodeReporter.reportNodes(sugo.relative_path + (sugo.single_code ? "##" + sugo.single_code : ""),curpagenoPV,curpagenamePV,JSON.stringify(nodeJSONArray), sugo.clientWidth, sugo.clientHeight, document.title);
                   }
                   return "ok";
               };
               sugo.getAssociatesElements = function (bindsArray = [], parentSimilarPath, s_path) {
                 s_path = s_path || "";
                 const getChildSimilarPath = (p_path, c_path) => {
                   var sameIdx = 0;
                   var dom = document.querySelector(c_path);
                   if(dom){
                       c_path = sugoioKit.cssPath(dom);
                   }
                   var pathLength = p_path.length;
                   var pPathList = p_path.split(" > ");
                   var cPathList = c_path.split(" > ");
                   var sPathList = s_path.split(" > ") || [];
                   var commonPathList = [];
                   if (s_path === "") {
                     commonPathList = cPathList;
                   }else {
                     for (var j = 0; j < cPathList.length; j++) {
                       if (cPathList[j]) {
                         if (pPathList[j]) {
                           if (pPathList[j].split("(")[0] === cPathList[j].split("(")[0]) {
                               if (sPathList[j] && sPathList[j].split("(")[1] && sPathList[j].split("(")[1].indexOf("n") === 0) {
                               commonPathList.push(pPathList[j]);
                             }else {
                               commonPathList.push(cPathList[j]);
                             }
                           } else if(pPathList[j].indexOf('swiper-slide-') !==0 && cPathList[j].indexOf('swiper-slide-') !== 0) {
                             commonPathList.push(pPathList[j])
                           } else {
                             commonPathList.push(cPathList[j]);
                           }
                         }else {
                           commonPathList.push(cPathList[j]);
                         }
                       }
                     }
                   }
                   var finalPath = commonPathList.join(" > ");
                   var doms = document.querySelectorAll(finalPath)|| [];
                   if (doms[0]) {
                     return finalPath;
                   }
                   for (let i = 0; i < pathLength; i++) {
                     if (p_path.charAt(i) !== c_path.charAt(i)) {
                       sameIdx = i;
                       break;
                     }
                   }
                   var similarIdex = p_path.substr(sameIdx).substring(0, p_path.substr(sameIdx).indexOf(")"));
                   var similarEndPath = c_path.substr(sameIdx).substring(c_path.substr(sameIdx).indexOf(")"));
                   return c_path.substring(0, sameIdx) + similarIdex + similarEndPath;
                 }
                 var p = {};
                 for(let i = 0; i < bindsArray.length; i++){
                     var bind = bindsArray[i];
                     let path = bind.path;
                     if (bind.similar) {
                       path = getChildSimilarPath(parentSimilarPath, path);
                     }
                     var innerText = sugo.extractElementsValue(path).join(",") || "";
                     if (innerText.length > 0) {
                         innerText = innerText.replace(/(^\s*)|(\s*$)/g, "");
                     }
                     p[bind.dimension] = innerText;
                 }
                 return p;
               };
               sugo.extractElementsValue = function (path) {
                  var values = [];
                  if (!path) {
                    return values;
                  }
                  var elems = document.querySelectorAll(path) || [];
                  for (var i = 0; i < elems.length; i++) {
                      var elem = elems[i];
                      if (elem.tagName && (elem.tagName === "INPUT" || elem.tagName === "SELECT")) {
                         values.push(elem.value);
                       } else if (elem.textContent) {
                         values.push(elem.textContent);
                       }else if (elem.innerText) {
                         values.push(elem.innerText);
                       }
                  }
                  return values;
               };
               sugo.delegate = function(eventType) {
                   function handle(e) {
                       var evt = window.event ? window.event : e;
//                       console.log("sugo.delegate,evt:" + JSON.stringify(evt) + ",current_event_bindings:" + JSON.stringify(sugo.current_event_bindings));
                       var target = evt.target || evt.srcElement;
                       var currentTarget = e ? e.currentTarget : this;
                       var paths = Object.keys(sugo.current_event_bindings);
                       var isMatch = false;
                       for (var idx = 0; idx < paths.length; idx++) {
                           var path_str = paths[idx];
                           var event = sugo.current_event_bindings[path_str];
                           if (event.event_type != eventType) {
//                               console.log("sugo.delegate,continue,eventType:" + eventType + ",event.event_type:" + event.event_type);
                               continue;
                           }
//                           console.log("sugo.delegate,eventType:" + eventType + ",event.event_type:" + event.event_type);
                           var path = event.path.path;
//                           console.log("sugo.delegate,event.path.path:" + path);
                           path = decodeURIComponent(path);
                           if (event.similar === true || event.similar === 1) {
                               path = event.similar_path ? event.similar_path.path.replace(/ &/g, '') : path.replace(/:nth-child\([0-9]*\)/g, "");
//                               console.log("sugo.delegate,sugo.event.similar_path:" + path);
                           }
                           if(path && path.indexOf("icbc:") !== -1){
                               path = path.replace(/icbc:(\w+)/g, "icbc\\:$1");
//                               console.log("sugo.delegate,path.indexOf(icbc:):" + path);
                           }
//                           console.log("sugo.delegate,path:" + path);
                           var eles = document.querySelectorAll(path) || [];
//                           console.log("sugo.delegate,eles:" + JSON.stringify(eles));

                           for (var eles_idx = 0; eles_idx < eles.length; eles_idx++) {
                               var ele = eles[eles_idx];
                               var parentNode = target;
//                               console.log("sugo.delegate,first parentNode:" + parentNode + ",ele:" + ele);
//                               console.log("sugo.delegate,first parentNode.text:" + parentNode.text + ",ele.text:" + ele.text);
//                               console.log("sugo.delegate,first parentNode.innerHTML:" + parentNode.innerHTML + ",ele.innerHTML:" + ele.innerHTML);
                               while (parentNode) {
//                                   console.log("sugo.delegate,parentNode:" + parentNode + ",ele:" + ele);
                                   if (parentNode === ele) {
//                                       console.log("sugo.delegate,parentNode === ele");
                                       var custom_props = JSON.parse(JSON.stringify(sugo.view_props));
                                       var hidden_ele = document.getElementById("eventdataid");
                                       if (!custom_props["eventdata_id"] && hidden_ele) {
                                           var eventdataId = hidden_ele.getAttribute("value");
                                           custom_props.eventdata_id = eventdataId;
                                       }
                                       var eventdataId = target.getAttribute("data-code") || parentNode.getAttribute("data-code");
                                       if (eventdataId){
                                           custom_props.eventdata_id = eventdataId;
                                       }
                                       if (event.code && event.code.replace(/(^\s*)|(\s*$)/g, "") != "") {
                                           try {
                                               var sugo_props = new Function("e", "element", "conf", "instance", event.code);
                                               var code_props = sugo_props(e, ele, event, sugo);
                                               if(code_props){
                                                 custom_props = Object.assign(custom_props, code_props);
                                               }
                                           } catch (e) {
                                               console.log(event.code);
                                           }
                                       }
                                       custom_props.from_binding = "1";
                                       custom_props.event_type = eventType;
                                       var innerText =  ele.innerText || "";
                                       if(innerText.length > 29){
                                          custom_props.event_label = innerText.substring(0,30);
                                       }else{
                                          custom_props.event_label = innerText;
                                       }
                                       custom_props.page_name = sugo.view_props["page_name"];
                                       custom_props.sugo_autotrack_path = path_str;
                                       custom_props.sugo_autotrack_page_path = sugo.relative_path;
                                       var data_code = target.getAttribute("data-code") || parentNode.getAttribute("data-code");
                                       if (data_code != null){
                                           custom_props.business_attribute = data_code;
                                       }
                                        if (event.binds) {
                                            var eventCssPath = sugoioKit.cssPath(ele);
                                            var keys = Object.keys(event.binds) || [];
                                            let bindsArray = keys.map((dimension) => {
                                                var record = event.binds[dimension];
                                                return {
                                                        dimension: dimension,
                                                        path: record.path,
                                                        similar: record.similar
                                                       };
                                            });
                                            var similar_path = (event.similar === true || event.similar === 1) ? event.similar_path.path.replace(/ &/g, '') : '';
                                            let bindProps =  sugo.getAssociatesElements(bindsArray, eventCssPath, similar_path);
                                            custom_props = Object.assign(custom_props, bindProps);
                                        }
                                       custom_props.isCensored = '1';
                                       custom_props.curpageurl = document.location.href;
//                                       console.log("sugo.delegate,event_name:" + event.event_name);
                                       sugo.rawTrack("", event.event_name, custom_props);
                                       isMatch = true;
                                       break;
                                   }
                                   parentNode = parentNode.parentNode;
                               }
                           }
                       }
                       if (isMatch || sugo.auto_track === "0") {
                             return;
                       }
                       var custom_props = JSON.parse(JSON.stringify(sugo.view_props));
                       var hidden_ele = document.getElementById("eventdataid");
                       if (!custom_props["eventdata_id"] && hidden_ele) {
                           var eventdataId = hidden_ele.getAttribute("value");
                           custom_props.eventdata_id = eventdataId;
                       }
                       var eventdataId = target.getAttribute("data-code");
                       if (eventdataId){
                           custom_props.eventdata_id = eventdataId;
                       }
                       var xpath = sugoioKit.cssPath(target).replace(/  /g," ");
                       custom_props.from_binding = "0";
                       custom_props.event_type = eventType;
                       if(target.innerText && target.innerText.length > 29){
                          custom_props.event_label = target.innerText.substring(0,30);
                       }else{
                          custom_props.event_label = target.innerText;
                       }
                       custom_props.page_name = sugo.view_props["page_name"];

                       custom_props.sugo_autotrack_path = xpath;
                       custom_props.sugo_autotrack_page_path = sugo.relative_path;
                       var event_name = "";
                       if (target.innerText === ""){
                           var ele = target.parentNode;
                           event_name = ele.innerText;
                       } else {
                           event_name = target.innerText;
                       }
                       event_name = event_name.length > 29 ? event_name.substring(0,29) : event_name;
                       if (event_name.replace(" ", "") === ""){
                           event_name = "全埋点事件";
                       }
                       var data_code = target.getAttribute("data-code");
                       if (data_code != null){
                           custom_props.business_attribute = data_code;
                       }
                       custom_props.isCensored = '0';
                       custom_props.curpageurl = document.location.href;
//                       console.log("sugo.delegate,event_name1:" + event.event_name);
                       sugo.rawTrack("", event_name, custom_props);

                   }
                   document.addEventListener(eventType, handle, true);
               };

               sugo.bindEvent = function () {
                   sugo.delegate("click");
                   sugo.delegate("focus");
                   sugo.delegate("change");
                   sugo.delegate("touchstart");
                   sugo.delegate("touchend");
               };

               if (!window.sugo) {
                   sugo.bindEvent();
               }
           sugo.registerPathName = function(){
                   var props = {};
                   if(sugo.single_code) {
                       props.path_name = sugo.relative_path + "##" + sugo.single_code;
                   } else {
                       props.path_name = sugo.relative_path;
                   }
                   window.sugoEventListener && window.sugoEventListener.registerPathName(props.path_name, sugo.sugo_hashcode);
               };
            sugo.registerPathName();
            sugo.init_path = function () {
                      sugo.current_page = sugo.relative_path + (sugo.single_code ? "##" + sugo.single_code : "");
                      sugo.current_event_bindings = {};
                      for (var i = 0; i < sugo.h5_event_bindings.length; i++) {
                       var b_event = sugo.h5_event_bindings[i];
                       if (b_event.target_activity === sugo.current_page || b_event.cross_page || b_event.target_activity === sugo.relative_path) {
                           var b_key = JSON.stringify(b_event.path);
                           sugo.current_event_bindings[b_key] = b_event;
                       }
                     }

                    var page_obj = sugo.all_page_info[sugo.relative_path + (sugo.single_code ? "##" + sugo.single_code : "")];
                    if(page_obj){
                    sugo.init = {
                        "code":page_obj.code,
                        "page_name": page_obj.page_name,
                        "page_category": page_obj.page_category
                    };
                   }else{
                       sugo.init = {
                            "code": "",
                            "page_name": "",
                            "page_category": ""
                       };
                   }

               };
               window.sugo = sugo;
            })(window.sugo || {});;

